package com.ejie.ab61.dao.procedimientos;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab61.comun.utilidades.SecuenciasSQL;
import com.ejie.ab61.dao.plantillas.CamposPlantillaDaoImpl;
import com.ejie.ab61.model.procedimientos.Aplicaciones;
import com.ejie.ab61.model.procedimientos.Areas;
import com.ejie.ab61.model.procedimientos.Departamentos;
import com.ejie.ab61.model.procedimientos.Direcciones;
import com.ejie.ab61.model.procedimientos.Procedimientos;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JQGridManager;
import com.ejie.x38.dto.JQGridManagerJerarquia;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ProcedimientosDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class ProcedimientosDaoImpl implements ProcedimientosDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDPROCEDIMIENTO", "CODPROCEDUREID", "FOLDERID",
			"FOLDERNUMBER", "CAMPOSTITULOEXPEDIENTE", "FECHAREGISTRO", "USUARIOREGISTRO", "DESCRIPCIONCASTELLANO",
			"DESCRIPCIONEUSKERA", "DIRECCIONESIDDIRECCION", "DIRECCIONESDESCRIPCIONES", "DIRECCIONESDESCRIPCIONEU",
			"DIRECCIONESFECHAREGISTRO", "DIRECCIONESUSUARIOREGISTRO", "AREASIDAREA", "AREASDESCRIPCIONCASTELLANO",
			"AREASDESCRIPCIONEUSKERA", "AREASFECHAREGISTRO", "AREASUSUARIOREGISTRO", "DIRECCIONESIDDEPARTAMENTO",
			"AREASIDDIRECCION", "INSPECCIONABLE", "APLICACIONESDESCCASTELLANO", "APLICACIONESDESCEUSKERA" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<Procedimientos> rwMap = new RowMapper<Procedimientos>() {
		public Procedimientos mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Procedimientos procedimiento = new Procedimientos();
			procedimiento.setIdProcedimiento(resultSet.getInt("IDPROCEDIMIENTO"));
			procedimiento.setDescripcionCastellano(resultSet.getString("DESCRIPCIONCASTELLANO"));
			procedimiento.setDescripcionEuskera(resultSet.getString("DESCRIPCIONEUSKERA"));
			procedimiento.setCodProcedureId(resultSet.getString("CODPROCEDUREID"));
			procedimiento.setCamposTituloExpediente(resultSet.getString("CAMPOSTITULOEXPEDIENTE"));
			procedimiento.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			procedimiento.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			procedimiento.setInspeccionable(resultSet.getBoolean("INSPECCIONABLE"));
			procedimiento.setExpedienteInspeccion(resultSet.getBoolean("EXPEDIENTEINSPECCION"));
			procedimiento.setExpedienteSancion(resultSet.getBoolean("EXPEDIENTESANCION"));
			procedimiento.setExpedienteDenuncia(resultSet.getBoolean("EXPEDIENTEDENUNCIA"));

			Direcciones direccion = new Direcciones();
			direccion.setIdDireccion(resultSet.getInt("DIRECCIONESIDDIRECCION"));
			direccion.setDescripcionCastellano(resultSet.getString("DIRECCIONESDESCRIPCIONES"));
			direccion.setDescripcionEuskera(resultSet.getString("DIRECCIONESDESCRIPCIONEU"));
			direccion.setFechaRegistro(resultSet.getDate("DIRECCIONESFECHAREGISTRO"));
			direccion.setUsuarioRegistro(resultSet.getString("DIRECCIONESUSUARIOREGISTRO"));

			Departamentos departamento = new Departamentos();
			departamento.setIdDepartamento(resultSet.getInt("DIRECCIONESIDDEPARTAMENTO"));
			direccion.setDepartamentos(departamento);

			Areas area = new Areas();
			area.setIdArea(resultSet.getInt("AreasIDAREA"));
			if (resultSet.wasNull()) {
				area.setIdArea(null);
			}
			area.setDescripcionCastellano(resultSet.getString("AREASDESCRIPCIONCASTELLANO"));
			area.setDescripcionEuskera(resultSet.getString("AREASDESCRIPCIONEUSKERA"));
			area.setFechaRegistro(resultSet.getDate("AREASFECHAREGISTRO"));
			area.setUsuarioRegistro(resultSet.getString("AREASUSUARIOREGISTRO"));

			Direcciones areasDireccion = new Direcciones();
			areasDireccion.setIdDireccion(resultSet.getInt("AREASIDDIRECCION"));
			area.setDirecciones(areasDireccion);

			procedimiento.setDirecciones(direccion);
			procedimiento.setAreas(area);

			Aplicaciones aplicacion = new Aplicaciones();
			aplicacion.setIdAplicacion(resultSet.getInt("APLICACIONESIDAPLICACION"));
			aplicacion.setDescripcionCastellano(resultSet.getString("APLICACIONESDESCCASTELLANO"));
			aplicacion.setDescripcionEuskera(resultSet.getString("APLICACIONESDESCEUSKERA"));
			aplicacion.setUrlAplicacion(resultSet.getString("APLICACIONESURLAPLICACION"));
			aplicacion.setFechaRegistro(resultSet.getDate("APLICACIONESFECHAREGISTRO"));
			aplicacion.setUsuarioRegistro(resultSet.getString("APLICACIONESUSUARIOREGISTRO"));

			procedimiento.setAplicacion(aplicacion);

			return procedimiento;

		}
	};

	private RowMapper<Procedimientos> rwMapProcedimientosDoc = new RowMapper<Procedimientos>() {
		public Procedimientos mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Procedimientos procedimiento = new Procedimientos();
			procedimiento.setIdProcedimiento(resultSet.getInt("IDPROCEDIMIENTO"));
			procedimiento.setDescripcionCastellano(resultSet.getString("DESCRIPCIONCASTELLANO"));
			procedimiento.setDescripcionEuskera(resultSet.getString("DESCRIPCIONEUSKERA"));

			return procedimiento;

		}
	};

	private RowMapper<Procedimientos> rwMapLista = new RowMapper<Procedimientos>() {
		public Procedimientos mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new Procedimientos(resultSet.getInt("IDPROCEDIMIENTO"), resultSet.getString("CODPROCEDUREID"), null,
					null, null, null, null, null, null, resultSet.getString("DESCRIPCIONCASTELLANO"),
					resultSet.getString("DESCRIPCIONEUSKERA"));
		}
	};

	private RowMapper<Procedimientos> rwMapPK = new RowMapper<Procedimientos>() {
		public Procedimientos mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new Procedimientos(resultSet.getInt("IDPROCEDIMIENTO"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<Procedimientos>> rwMapJerarquia = new RowMapper<JerarquiaDto<Procedimientos>>() {
		public JerarquiaDto<Procedimientos> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Procedimientos procedimientos = new Procedimientos(resultSet.getInt("IDPROCEDIMIENTO"),
					resultSet.getString("DESCRIPCIONCASTELLANO"), resultSet.getString("DESCRIPCIONEUSKERA"),
					resultSet.getString("CODPROCEDUREID"), resultSet.getString("CAMPOSTITULOEXPEDIENTE"),
					resultSet.getDate("FECHAREGISTRO"), resultSet.getString("USUARIOREGISTRO"),
					new Direcciones(resultSet.getInt("DireccionesIDDIRECCION"),
							resultSet.getString("DIRECCIONESDESCRIPCIONES"),
							resultSet.getString("DIRECCIONESDESCRIPCIONEU"),
							resultSet.getDate("DireccionesFECHAREGISTRO"),
							resultSet.getString("DireccionesUSUARIOREGISTRO"),
							new Departamentos(resultSet.getInt("DireccionesIDDEPARTAMENTO"), null, null, null, null,
									null)),
					new Areas(resultSet.getInt("AreasIDAREA"), resultSet.getString("AreasDESCRIPCIONCASTELLANO"),
							resultSet.getString("AreasDESCRIPCIONEUSKERA"), resultSet.getDate("AreasFECHAREGISTRO"),
							resultSet.getString("AreasUSUARIOREGISTRO"), new Direcciones(
									resultSet.getInt("AreasIDDIRECCION"), null, null, null, null, null, null, null)),
					resultSet.getBoolean("INSPECCIONABLE"));

			JerarquiaDto<Procedimientos> jerarquia = new JerarquiaDto<Procedimientos>();
			jerarquia.setModel(procedimientos);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the Procedimientos table.
	 *
	 * @param procedimientos
	 *            Procedimientos
	 * @return Procedimientos
	 */
	public Procedimientos add(Procedimientos procedimientos) {
		int idProcedimiento = this.jdbcTemplate.queryForInt(SecuenciasSQL.getSelectNext("AB61.S_AB6101T00"));
		procedimientos.setIdProcedimiento(idProcedimiento);

		String query = "INSERT INTO PROCEDIMIENTOS (ID_PROCEDIMIENTO, DESCRIPCION_CASTELLANO, DESCRIPCION_EUSKERA, ID_DIRECCION, ID_AREA, COD_PROCEDURE_ID, CAMPOS_TITULO_EXPEDIENTE, FECHA_REGISTRO, USUARIO_REGISTRO, INSPECCIONABLE, ID_APLICACION, EXPEDIENTE_INSPECCION, EXPEDIENTE_SANCION, EXPEDIENTE_DENUNCIA) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
		Object getDireccionesIdDireccionAux = null;
		if (procedimientos.getDirecciones() != null && procedimientos.getDirecciones().getIdDireccion() != null) {
			getDireccionesIdDireccionAux = procedimientos.getDirecciones().getIdDireccion();
		}
		Object getAreasIdAreaAux = null;
		if (procedimientos.getAreas() != null && procedimientos.getAreas().getIdArea() != null) {
			getAreasIdAreaAux = procedimientos.getAreas().getIdArea();
		}
		Object idAplicacionesAux = null;
		if (procedimientos.getAplicacion() != null && procedimientos.getAplicacion().getIdAplicacion() != null) {
			idAplicacionesAux = procedimientos.getAplicacion().getIdAplicacion();
		}
		this.jdbcTemplate.update(query, procedimientos.getIdProcedimiento(), procedimientos.getDescripcionCastellano(),
				procedimientos.getDescripcionEuskera(), getDireccionesIdDireccionAux, getAreasIdAreaAux,
				procedimientos.getCodProcedureId(), procedimientos.getCamposTituloExpediente(),
				procedimientos.getFechaRegistro(), procedimientos.getUsuarioRegistro(),
				procedimientos.isInspeccionable(), idAplicacionesAux, procedimientos.isExpedienteInspeccion(),
				procedimientos.isExpedienteSancion(), procedimientos.isExpedienteDenuncia());
		return procedimientos;
	}

	/**
	 * Updates a single row in the Procedimientos table.
	 *
	 * @param procedimientos
	 *            Procedimientos
	 * @return Procedimientos
	 */
	public Procedimientos update(Procedimientos procedimientos) {
		String query = "UPDATE PROCEDIMIENTOS SET ID_DIRECCION=?, ID_AREA=?, DESCRIPCION_CASTELLANO=?, DESCRIPCION_EUSKERA=?, COD_PROCEDURE_ID=?, CAMPOS_TITULO_EXPEDIENTE=?, INSPECCIONABLE=?, ID_APLICACION=?, EXPEDIENTE_INSPECCION=?, EXPEDIENTE_SANCION=?, EXPEDIENTE_DENUNCIA=?, FECHA_ULTMODIFICACION=?, USUARIO_ULTMODIFICACION=? WHERE ID_PROCEDIMIENTO=?";
		Object getDireccionesIdDireccionAux = null;
		if (procedimientos.getDirecciones() != null && procedimientos.getDirecciones().getIdDireccion() != null) {
			getDireccionesIdDireccionAux = procedimientos.getDirecciones().getIdDireccion();
		}
		Object getAreasIdAreaAux = null;
		if (procedimientos.getAreas() != null && procedimientos.getAreas().getIdArea() != null) {
			getAreasIdAreaAux = procedimientos.getAreas().getIdArea();
		}
		Object idAplicacionesAux = null;
		if (procedimientos.getAplicacion() != null && procedimientos.getAplicacion().getIdAplicacion() != null) {
			idAplicacionesAux = procedimientos.getAplicacion().getIdAplicacion();
		}
		this.jdbcTemplate.update(query, getDireccionesIdDireccionAux, getAreasIdAreaAux,
				procedimientos.getDescripcionCastellano(), procedimientos.getDescripcionEuskera(),
				procedimientos.getCodProcedureId(), procedimientos.getCamposTituloExpediente(),
				procedimientos.isInspeccionable(), idAplicacionesAux, procedimientos.isExpedienteInspeccion(),
				procedimientos.isExpedienteSancion(), procedimientos.isExpedienteDenuncia(),
				procedimientos.getFechaUltmodificacion(), procedimientos.getUsuarioUltmodificacion(),
				procedimientos.getIdProcedimiento());
		return procedimientos;
	}

	/**
	 * Finds a single row in the Procedimientos table.
	 *
	 * @param procedimientos
	 *            Procedimientos
	 * @return Procedimientos
	 */
	@Transactional(readOnly = true)
	public Procedimientos find(Procedimientos procedimientos) {
		String query = "SELECT t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t1.COD_PROCEDURE_ID CODPROCEDUREID, t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA, t1.CAMPOS_TITULO_EXPEDIENTE CAMPOSTITULOEXPEDIENTE, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.INSPECCIONABLE INSPECCIONABLE, t1.EXPEDIENTE_INSPECCION EXPEDIENTEINSPECCION, t1.EXPEDIENTE_SANCION EXPEDIENTESANCION, t1.EXPEDIENTE_DENUNCIA EXPEDIENTEDENUNCIA, t2.ID_DIRECCION DIRECCIONESIDDIRECCION, t2.DESCRIPCION_CASTELLANO DIRECCIONESDESCRIPCIONES, t2.DESCRIPCION_EUSKERA DIRECCIONESDESCRIPCIONEU, t2.FECHA_REGISTRO DIRECCIONESFECHAREGISTRO, t2.USUARIO_REGISTRO DIRECCIONESUSUARIOREGISTRO, t3.ID_AREA AREASIDAREA, t3.DESCRIPCION_CASTELLANO AREASDESCRIPCIONCASTELLANO, t3.DESCRIPCION_EUSKERA AREASDESCRIPCIONEUSKERA, t3.FECHA_REGISTRO AREASFECHAREGISTRO, t3.USUARIO_REGISTRO AREASUSUARIOREGISTRO, t2.ID_DEPARTAMENTO DIRECCIONESIDDEPARTAMENTO, t3.ID_DIRECCION AREASIDDIRECCION, t4.ID_APLICACION APLICACIONESIDAPLICACION, t4.DESCRIPCION_CASTELLANO APLICACIONESDESCCASTELLANO, t4.DESCRIPCION_EUSKERA APLICACIONESDESCEUSKERA, t4.URL_APLICACION APLICACIONESURLAPLICACION, t4.FECHA_REGISTRO APLICACIONESFECHAREGISTRO, t4.USUARIO_REGISTRO APLICACIONESUSUARIOREGISTRO FROM PROCEDIMIENTOS t1 , DIRECCIONES t2 , AREAS t3, APLICACIONES t4  WHERE t1.ID_PROCEDIMIENTO = ?   AND t1.ID_DIRECCION= t2.ID_DIRECCION(+) AND t1.ID_AREA= t3.ID_AREA(+) AND t1.ID_DIRECCION= t3.ID_DIRECCION(+) AND t1.ID_APLICACION = t4.ID_APLICACION(+) ";

		List<Procedimientos> procedimientosList = this.jdbcTemplate.query(query, this.rwMap,
				procedimientos.getIdProcedimiento());
		return (Procedimientos) DataAccessUtils.uniqueResult(procedimientosList);
	}

	/**
	 * Finds a single row in the Procedimientos table.
	 *
	 * @param procedimientos
	 *            Procedimientos
	 * @return Procedimientos
	 */
	@Transactional(readOnly = true)
	public Procedimientos findProc(Procedimientos procedimientos) {
		String query = "SELECT t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA, t1.COD_PROCEDURE_ID CODPROCEDUREID, t1.CAMPOS_TITULO_EXPEDIENTE CAMPOSTITULOEXPEDIENTE, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.INSPECCIONABLE INSPECCIONABLE, t1.ID_APLICACION IDAPLICACION, t1.EXPEDIENTE_INSPECCION EXPEDIENTEINSPECCION, t1.EXPEDIENTE_SANCION EXPEDIENTESANCION, t1.EXPEDIENTE_DENUNCIA EXPEDIENTEDENUNCIA, t2.ID_DIRECCION DIRECCIONESIDDIRECCION, t2.DESCRIPCION_CASTELLANO DIRECCIONESCASTELLANO, t2.DESCRIPCION_EUSKERA DIRECCIONESEUSKERA, t2.FECHA_REGISTRO DIRECCIONESFECHAREGISTRO, t2.USUARIO_REGISTRO DIRECCIONESUSUARIOREGISTRO, t3.ID_AREA AREASIDAREA, t3.DESCRIPCION_CASTELLANO AREASDESCRIPCIONCASTELLANO, t3.DESCRIPCION_EUSKERA AREASDESCRIPCIONEUSKERA, t3.FECHA_REGISTRO AREASFECHAREGISTRO, t3.USUARIO_REGISTRO AREASUSUARIOREGISTRO, t2.ID_DEPARTAMENTO DIRECCIONESIDDEPARTAMENTO, t3.ID_DIRECCION AREASIDDIRECCION, t4.ID_APLICACION APLICACIONESIDAPLICACION, t4.DESCRIPCION_CASTELLANO APLICACIONESDESCCASTELLANO, t4.DESCRIPCION_EUSKERA APLICACIONESDESCEUSKERA, t4.URL_APLICACION APLICACIONESURLAPLICACION, t4.FECHA_REGISTRO APLICACIONESFECHAREGISTRO, t4.USUARIO_REGISTRO APLICACIONESUSUARIOREGISTRO FROM AB61.PROCEDIMIENTOS t1 , AB61.DIRECCIONES t2 , AB61.AREAS t3, AB61.APLICACIONES t4  WHERE t1.COD_PROCEDURE_ID = ? AND t1.ID_DIRECCION= t2.ID_DIRECCION(+) AND t1.ID_AREA= t3.ID_AREA(+) AND t1.ID_APLICACION = t4.ID_APLICACION(+) ";

		List<Procedimientos> procedimientosList = this.jdbcTemplate.query(query, this.rwMap,
				procedimientos.getCodProcedureId());
		return (Procedimientos) DataAccessUtils.uniqueResult(procedimientosList);
	}

	/**
	 * Finds a single row in the Procedimientos table.
	 *
	 * @param procedimientos
	 *            String
	 * @return Procedimientos
	 */
	@Transactional(readOnly = true)
	public Procedimientos findByProcedimento(String procedimientoId) {
		String query = "SELECT t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO  FROM PROCEDIMIENTOS t1  WHERE  COD_PROCEDURE_ID= ?";

		List<Procedimientos> procedimientosList = this.jdbcTemplate.query(query, this.rwMapPK, procedimientoId);
		return (Procedimientos) DataAccessUtils.uniqueResult(procedimientosList);
	}

	@Override
	public Integer getNumeroExpedientes(Procedimientos procedimiento) {
		String query = "SELECT COUNT(1) NUMEXPEDIENTES FROM EXPEDIENTES t1 WHERE t1.ID_PROCEDIMIENTO = ?";
		return this.jdbcTemplate.queryForInt(query, procedimiento.getIdProcedimiento());
	}

	/**
	 * Removes a single row in the Procedimientos table.
	 *
	 * @param procedimientos
	 *            Procedimientos
	 * @return
	 */
	public void remove(Procedimientos procedimientos) {
		String query = "DELETE FROM PROCEDIMIENTOS WHERE ID_PROCEDIMIENTO=?";
		this.jdbcTemplate.update(query, procedimientos.getIdProcedimiento());
	}

	/**
	 * Finds a list of rows in the Procedimientos table.
	 *
	 * @param procedimientos
	 *            Procedimientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Procedimientos>
	 */
	@Transactional(readOnly = true)
	public List<Procedimientos> findAll(Procedimientos procedimientos, JQGridRequestDto jqGridRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO,t1.COD_PROCEDURE_ID CODPROCEDUREID,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA ");
		query.append("FROM PROCEDIMIENTOS t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(procedimientos);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (jqGridRequestDto != null) {
			query = JQGridManager.getPaginationQuery(jqGridRequestDto, query,
					ProcedimientosDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<Procedimientos>) this.jdbcTemplate.query(query.toString(), this.rwMapLista, params.toArray());
	}

	@Override
	public List<Procedimientos> findAllProcEnlazado(Procedimientos procedimientos) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO,t1.COD_PROCEDURE_ID CODPROCEDUREID,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA ");
		query.append("FROM PROCEDIMIENTOS t1, DIRECCIONES t2 ");
		query.append("WHERE 1=1 AND t2.ID_DIRECCION = ? AND t2.ID_DIRECCION = t1.ID_DIRECCION");

		return (List<Procedimientos>) this.jdbcTemplate.query(query.toString(), this.rwMapLista,
				procedimientos.getDirecciones().getIdDireccion());
	}

	/**
	 * Finds rows in the Procedimientos table using like.
	 *
	 * @param procedimientos
	 *            Procedimientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Procedimientos>
	 */
	@Transactional(readOnly = true)
	public List<Procedimientos> findAllLike(Procedimientos procedimientos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.COD_PROCEDURE_ID CODPROCEDUREID,t1.CAMPOS_TITULO_EXPEDIENTE CAMPOSTITULOEXPEDIENTE,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.INSPECCIONABLE INSPECCIONABLE, t1.ID_APLICACION IDAPLICACION, t1.EXPEDIENTE_INSPECCION EXPEDIENTEINSPECCION, t1.EXPEDIENTE_SANCION EXPEDIENTESANCION, t1.EXPEDIENTE_DENUNCIA EXPEDIENTEDENUNCIA, t2.ID_DIRECCION DIRECCIONESIDDIRECCION,t2.DESCRIPCION_CASTELLANO DIRECCIONESDESCRIPCIONES,t2.DESCRIPCION_EUSKERA DIRECCIONESDESCRIPCIONEU,t2.FECHA_REGISTRO DIRECCIONESFECHAREGISTRO,t2.USUARIO_REGISTRO DIRECCIONESUSUARIOREGISTRO,t3.ID_AREA AREASIDAREA,t3.DESCRIPCION_CASTELLANO AREASDESCRIPCIONCASTELLANO,t3.DESCRIPCION_EUSKERA AREASDESCRIPCIONEUSKERA,t3.FECHA_REGISTRO AREASFECHAREGISTRO,t3.USUARIO_REGISTRO AREASUSUARIOREGISTRO,t2.ID_DEPARTAMENTO DIRECCIONESIDDEPARTAMENTO,t3.ID_DIRECCION AREASIDDIRECCION, t4.ID_APLICACION APLICACIONESIDAPLICACION, t4.DESCRIPCION_CASTELLANO APLICACIONESDESCCASTELLANO, t4.DESCRIPCION_EUSKERA APLICACIONESDESCEUSKERA, t4.URL_APLICACION APLICACIONESURLAPLICACION, t4.FECHA_REGISTRO APLICACIONESFECHAREGISTRO, t4.USUARIO_REGISTRO APLICACIONESUSUARIOREGISTRO ");
		query.append("FROM PROCEDIMIENTOS t1 ,DIRECCIONES t2 ,AREAS t3, APLICACIONES t4 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(procedimientos, startsWith);
		StringBuilder where = new StringBuilder(
				" WHERE 1=1 AND t1.ID_DIRECCION= t2.ID_DIRECCION(+) AND t1.ID_AREA= t3.ID_AREA(+) AND t1.ID_DIRECCION= t3.ID_DIRECCION(+) AND t1.ID_APLICACION = t4.ID_APLICACION(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (jqGridRequestDto != null) {
			query = JQGridManager.getPaginationQuery(jqGridRequestDto, query,
					ProcedimientosDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<Procedimientos>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the Procedimientos table.
	 *
	 * @param procedimientos
	 *            Procedimientos
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(Procedimientos procedimientos) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM PROCEDIMIENTOS t1 , DIRECCIONES t2 , AREAS t3 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(procedimientos);
		StringBuilder where = new StringBuilder(
				" WHERE 1=1 AND t1.ID_DIRECCION= t2.ID_DIRECCION(+) AND t1.ID_AREA= t3.ID_AREA(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForLong(query.toString(), params.toArray());
	}

	/**
	 * Counts rows in the Procedimientos table using like.
	 *
	 * @param procedimientos
	 *            Procedimientos
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(Procedimientos procedimientos, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM PROCEDIMIENTOS t1 ,DIRECCIONES t2 ,AREAS t3 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(procedimientos, startsWith);
		StringBuilder where = new StringBuilder(
				" WHERE 1=1 AND t1.ID_DIRECCION= t2.ID_DIRECCION(+) AND t1.ID_AREA= t3.ID_AREA(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForLong(query.toString(), params.toArray());
	}

	/**
	 * Reorder the data list of Procedimientos selected for rup_table
	 *
	 * @param procedimientos
	 *            Procedimientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Procedimientos>>
	 */
	@Override
	public List<TableRowDto<Procedimientos>> reorderSelection(Procedimientos procedimientos,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO,t1.COD_PROCEDURE_ID CODPROCEDUREID,t1.CAMPOS_TITULO_EXPEDIENTE CAMPOSTITULOEXPEDIENTE,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.INSPECCIONABLE INSPECCIONABLE,t2.ID_DIRECCION DIRECCIONESIDDIRECCION,t2.DESCRIPCION_CASTELLANO DIRECCIONESDESCRIPCIONES,t2.DESCRIPCION_EUSKERA DIRECCIONESDESCRIPCIONEU,t2.FECHA_REGISTRO DIRECCIONESFECHAREGISTRO,t2.USUARIO_REGISTRO DIRECCIONESUSUARIOREGISTRO,t3.ID_AREA AREASIDAREA,t3.DESCRIPCION_CASTELLANO AREASDESCRIPCIONCASTELLANO,t3.DESCRIPCION_EUSKERA AREASDESCRIPCIONEUSKERA,t3.FECHA_REGISTRO AREASFECHAREGISTRO,t3.USUARIO_REGISTRO AREASUSUARIOREGISTRO,t2.ID_DEPARTAMENTO DIRECCIONESIDDEPARTAMENTO,t3.ID_DIRECCION AREASIDDIRECCION ");
		// FROM
		query.append("FROM PROCEDIMIENTOS t1 ,DIRECCIONES t2 ,AREAS t3 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(procedimientos, startsWith);
		StringBuilder where = new StringBuilder(
				" WHERE 1=1 AND t1.ID_DIRECCION= t2.ID_DIRECCION(+) AND t1.ID_AREA= t3.ID_AREA(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = JQGridManager.getReorderQuery(query, jqGridRequestDto,
				Procedimientos.class, filterParamList, "ID_PROCEDIMIENTO");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<Procedimientos>(this.rwMapPK, jqGridRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            Procedimientos
	 * @param searchParams
	 *            Procedimientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Procedimientos>>
	 */
	@Override
	public List<TableRowDto<Procedimientos>> search(Procedimientos filterParams, Procedimientos searchParams,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO,t1.COD_PROCEDURE_ID CODPROCEDUREID,t1.CAMPOS_TITULO_EXPEDIENTE CAMPOSTITULOEXPEDIENTE,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t2.ID_DIRECCION DIRECCIONESIDDIRECCION,t2.DESCRIPCION_CASTELLANO DIRECCIONESDESCRIPCIONES,t2.DESCRIPCION_EUSKERA DIRECCIONESDESCRIPCIONEU,t2.FECHA_REGISTRO DIRECCIONESFECHAREGISTRO,t2.USUARIO_REGISTRO DIRECCIONESUSUARIOREGISTRO,t3.ID_AREA AREASIDAREA,t3.DESCRIPCION_CASTELLANO AREASDESCRIPCIONCASTELLANO,t3.DESCRIPCION_EUSKERA AREASDESCRIPCIONEUSKERA,t3.FECHA_REGISTRO AREASFECHAREGISTRO,t3.USUARIO_REGISTRO AREASUSUARIOREGISTRO,t2.ID_DEPARTAMENTO DIRECCIONESIDDEPARTAMENTO,t3.ID_DIRECCION AREASIDDIRECCION ");
		// FROM
		query.append("FROM PROCEDIMIENTOS t1 ,DIRECCIONES t2 ,AREAS t3 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");
		from_alias.add(" t3 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(
				" WHERE 1=1 AND t1.ID_DIRECCION= t2.ID_DIRECCION(+) AND t1.ID_AREA= t3.ID_AREA(+) ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = JQGridManager.getSearchQuery(query, jqGridRequestDto,
				Procedimientos.class, filterParamList, searchSQL, searchParamList, from_alias, "ID_PROCEDIMIENTO");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<Procedimientos>(this.rwMapPK, jqGridRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filterprocedimientos
	 *            Procedimientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(Procedimientos filterprocedimientos, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO,t1.COD_PROCEDURE_ID CODPROCEDUREID,t1.CAMPOS_TITULO_EXPEDIENTE CAMPOSTITULOEXPEDIENTE,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t2.ID_DIRECCION DIRECCIONESIDDIRECCION,t2.DESCRIPCION_CASTELLANO DIRECCIONESDESCRIPCIONES,t2.DESCRIPCION_EUSKERA DIRECCIONESDESCRIPCIONEU,t2.FECHA_REGISTRO DIRECCIONESFECHAREGISTRO,t2.USUARIO_REGISTRO DIRECCIONESUSUARIOREGISTRO,t3.ID_AREA AREASIDAREA,t3.DESCRIPCION_CASTELLANO AREASDESCRIPCIONCASTELLANO,t3.DESCRIPCION_EUSKERA AREASDESCRIPCIONEUSKERA,t3.FECHA_REGISTRO AREASFECHAREGISTRO,t3.USUARIO_REGISTRO AREASUSUARIOREGISTRO,t2.ID_DEPARTAMENTO DIRECCIONESIDDEPARTAMENTO,t3.ID_DIRECCION AREASIDDIRECCION ");
		// FROM
		query.append("FROM PROCEDIMIENTOS t1 ,DIRECCIONES t2 ,AREAS t3 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterprocedimientos, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = JQGridManager.getRemoveMultipleQuery(jqGridRequestDto, Procedimientos.class,
				query, params, "ID_PROCEDIMIENTO");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical Procedimientos table.
	 *
	 * @param filterProcedimientos
	 *            Procedimientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<Procedimientos>>
	 */
	@Override
	public List<JerarquiaDto<Procedimientos>> findAllLikeJerarquia(Procedimientos filterProcedimientos,
			JQGridRequestDto jqGridRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO,t1.COD_PROCEDURE_ID CODPROCEDUREID,t1.CAMPOS_TITULO_EXPEDIENTE CAMPOSTITULOEXPEDIENTE,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.INSPECCIONABLE INSPECCIONABLE,t2.ID_DIRECCION DIRECCIONESIDDIRECCION,t2.DESCRIPCION_CASTELLANO DIRECCIONESDESCRIPCIONES,t2.DESCRIPCION_EUSKERA DIRECCIONESDESCRIPCIONEU,t2.FECHA_REGISTRO DIRECCIONESFECHAREGISTRO,t2.USUARIO_REGISTRO DIRECCIONESUSUARIOREGISTRO,t3.ID_AREA AREASIDAREA,t3.DESCRIPCION_CASTELLANO AREASDESCRIPCIONCASTELLANO,t3.DESCRIPCION_EUSKERA AREASDESCRIPCIONEUSKERA,t3.FECHA_REGISTRO AREASFECHAREGISTRO,t3.USUARIO_REGISTRO AREASUSUARIOREGISTRO,t2.ID_DEPARTAMENTO DIRECCIONESIDDEPARTAMENTO,t3.ID_DIRECCION AREASIDDIRECCION ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM PROCEDIMIENTOS t1
		// ,DIRECCIONES t2 ,AREAS t3 ");
		List<String> from = new ArrayList<String>();
		from.add("PROCEDIMIENTOS");
		from.add("DIRECCIONES");
		from.add("AREAS");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");
		from_alias.add(" t3 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterProcedimientos, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = JQGridManagerJerarquia.getQuery(jqGridRequestDto, query, mapaWhere, "ID_PROCEDIMIENTO", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = JQGridManagerJerarquia.getQuery(jqGridRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (jqGridRequestDto != null) {
			query = JQGridManagerJerarquia.getPaginationQuery(jqGridRequestDto, query,
					ProcedimientosDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterProcedimientos
	 *            Procedimientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(Procedimientos filterProcedimientos, JQGridRequestDto jqGridRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM PROCEDIMIENTOS t1
		// ,DIRECCIONES t2 ,AREAS t3 ");
		List<String> from = new ArrayList<String>();
		from.add("PROCEDIMIENTOS");
		from.add("DIRECCIONES");
		from.add("AREAS");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");
		from_alias.add(" t3 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterProcedimientos, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = JQGridManagerJerarquia.getQueryCount(jqGridRequestDto, mapaWhere, "ID_PROCEDIMIENTO",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// JQGridManagerJerarquia.getQueryCount(jqGridRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForLong(query.toString(), params.toArray());
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterProcedimientos
	 *            Procedimientos
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<Procedimientos>>
	 */
	@Override
	public List<TableRowDto<Procedimientos>> findAllChild(Procedimientos filterProcedimientos,
			JQGridRequestDto jqGridRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM PROCEDIMIENTOS t1
		// ,DIRECCIONES t2 ,AREAS t3 ");
		List<String> from = new ArrayList<String>();
		from.add("PROCEDIMIENTOS");
		from.add("DIRECCIONES");
		from.add("AREAS");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");
		from_alias.add(" t3 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterProcedimientos, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = JQGridManagerJerarquia.getQueryChildren(jqGridRequestDto, mapaWhere, "ID_PROCEDIMIENTO",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// JQGridManagerJerarquia.getQueryChildren(jqGridRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<Procedimientos>(this.rwMapPK, "ID_PROCEDIMIENTO"), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the Procedimientos entity
	 *
	 * @param procedimientos
	 *            Procedimientos Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(Procedimientos procedimientos) {

		StringBuilder where = new StringBuilder(ProcedimientosDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (procedimientos != null && procedimientos.getIdProcedimiento() != null) {
			where.append(" AND t1.ID_PROCEDIMIENTO = ?");
			params.add(procedimientos.getIdProcedimiento());
		}
		if (procedimientos != null && procedimientos.getDirecciones() != null
				&& procedimientos.getDirecciones().getIdDireccion() != null) {
			where.append(" AND t2.ID_DIRECCION = ?");
			params.add(procedimientos.getDirecciones().getIdDireccion());
		}
		if (procedimientos != null && procedimientos.getDirecciones() != null
				&& procedimientos.getDirecciones().getDepartamentos() != null
				&& procedimientos.getDirecciones().getDepartamentos().getIdDepartamento() != null) {
			where.append(" AND t2.ID_DEPARTAMENTO = ?");
			params.add(procedimientos.getDirecciones().getDepartamentos().getIdDepartamento());
		}
		if (procedimientos != null && procedimientos.getDirecciones() != null
				&& procedimientos.getDirecciones().getDescripcionCastellano() != null) {
			where.append(" AND t2.DESCRIPCION_CASTELLANO = ?");
			params.add(procedimientos.getDirecciones().getDescripcionCastellano());
		}
		if (procedimientos != null && procedimientos.getDirecciones() != null
				&& procedimientos.getDirecciones().getDescripcionEuskera() != null) {
			where.append(" AND t2.DESCRIPCION_EUSKERA = ?");
			params.add(procedimientos.getDirecciones().getDescripcionEuskera());
		}
		if (procedimientos != null && procedimientos.getDirecciones() != null
				&& procedimientos.getDirecciones().getFechaRegistro() != null) {
			where.append(" AND t2.FECHA_REGISTRO = ?");
			params.add(procedimientos.getDirecciones().getFechaRegistro());
		}
		if (procedimientos != null && procedimientos.getDirecciones() != null
				&& procedimientos.getDirecciones().getUsuarioRegistro() != null) {
			where.append(" AND t2.USUARIO_REGISTRO = ?");
			params.add(procedimientos.getDirecciones().getUsuarioRegistro());
		}
		if (procedimientos != null && procedimientos.getAreas() != null
				&& procedimientos.getAreas().getIdArea() != null) {
			where.append(" AND t3.ID_AREA = ?");
			params.add(procedimientos.getAreas().getIdArea());
		}
		if (procedimientos != null && procedimientos.getAreas() != null
				&& procedimientos.getAreas().getDirecciones() != null
				&& procedimientos.getAreas().getDirecciones().getIdDireccion() != null) {
			where.append(" AND t3.ID_DIRECCION = ?");
			params.add(procedimientos.getAreas().getDirecciones().getIdDireccion());
		}
		if (procedimientos != null && procedimientos.getAreas() != null
				&& procedimientos.getAreas().getDescripcionCastellano() != null) {
			where.append(" AND t3.DESCRIPCION_CASTELLANO = ?");
			params.add(procedimientos.getAreas().getDescripcionCastellano());
		}
		if (procedimientos != null && procedimientos.getAreas() != null
				&& procedimientos.getAreas().getDescripcionEuskera() != null) {
			where.append(" AND t3.DESCRIPCION_EUSKERA = ?");
			params.add(procedimientos.getAreas().getDescripcionEuskera());
		}
		if (procedimientos != null && procedimientos.getAreas() != null
				&& procedimientos.getAreas().getFechaRegistro() != null) {
			where.append(" AND t3.FECHA_REGISTRO = ?");
			params.add(procedimientos.getAreas().getFechaRegistro());
		}
		if (procedimientos != null && procedimientos.getAreas() != null
				&& procedimientos.getAreas().getUsuarioRegistro() != null) {
			where.append(" AND t3.USUARIO_REGISTRO = ?");
			params.add(procedimientos.getAreas().getUsuarioRegistro());
		}
		if (procedimientos != null && procedimientos.getCodProcedureId() != null) {
			where.append(" AND t1.COD_PROCEDURE_ID = ?");
			params.add(procedimientos.getCodProcedureId());
		}
		if (procedimientos != null && procedimientos.getCamposTituloExpediente() != null) {
			where.append(" AND t1.CAMPOS_TITULO_EXPEDIENTE = ?");
			params.add(procedimientos.getCamposTituloExpediente());
		}
		if (procedimientos != null && procedimientos.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(procedimientos.getFechaRegistro());
		}
		if (procedimientos != null && procedimientos.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(procedimientos.getUsuarioRegistro());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the Procedimientos entity
	 *
	 * @param procedimientos
	 *            Procedimientos Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(Procedimientos procedimientos, Boolean startsWith) {

		StringBuilder where = new StringBuilder(ProcedimientosDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (procedimientos != null && procedimientos.getIdProcedimiento() != null) {
			where.append(" AND t1.ID_PROCEDIMIENTO = ?");
			params.add(procedimientos.getIdProcedimiento());
		}
		if (procedimientos != null && procedimientos.getDirecciones() != null
				&& procedimientos.getDirecciones().getIdDireccion() != null) {
			where.append(" AND t2.ID_DIRECCION = ?");
			params.add(procedimientos.getDirecciones().getIdDireccion());
		}
		if (procedimientos != null && procedimientos.getDirecciones() != null
				&& procedimientos.getDirecciones().getDepartamentos() != null
				&& procedimientos.getDirecciones().getDepartamentos().getIdDepartamento() != null) {
			where.append(" AND t2.ID_DEPARTAMENTO = ?");
			params.add(procedimientos.getDirecciones().getDepartamentos().getIdDepartamento());
		}
		if (procedimientos != null && procedimientos.getDirecciones() != null
				&& procedimientos.getDirecciones().getDescripcionCastellano() != null) {
			where.append(" AND UPPER(t2.DESCRIPCION_CASTELLANO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(procedimientos.getDirecciones().getDescripcionCastellano().toUpperCase() + "%");
			} else {
				params.add("%" + procedimientos.getDirecciones().getDescripcionCastellano().toUpperCase() + "%");
			}
			where.append(" AND t2.DESCRIPCION_CASTELLANO IS NOT NULL");
		}
		if (procedimientos != null && procedimientos.getDirecciones() != null
				&& procedimientos.getDirecciones().getDescripcionEuskera() != null) {
			where.append(" AND UPPER(t2.DESCRIPCION_EUSKERA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(procedimientos.getDirecciones().getDescripcionEuskera().toUpperCase() + "%");
			} else {
				params.add("%" + procedimientos.getDirecciones().getDescripcionEuskera().toUpperCase() + "%");
			}
			where.append(" AND t2.DESCRIPCION_EUSKERA IS NOT NULL");
		}
		if (procedimientos != null && procedimientos.getDirecciones() != null
				&& procedimientos.getDirecciones().getFechaRegistro() != null) {
			where.append(" AND t2.FECHA_REGISTRO = ?");
			params.add(procedimientos.getDirecciones().getFechaRegistro());
		}
		if (procedimientos != null && procedimientos.getDirecciones() != null
				&& procedimientos.getDirecciones().getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t2.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(procedimientos.getDirecciones().getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + procedimientos.getDirecciones().getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t2.USUARIO_REGISTRO IS NOT NULL");
		}
		if (procedimientos != null && procedimientos.getAreas() != null
				&& procedimientos.getAreas().getIdArea() != null) {
			where.append(" AND t3.ID_AREA = ?");
			params.add(procedimientos.getAreas().getIdArea());
		}
		if (procedimientos != null && procedimientos.getAreas() != null
				&& procedimientos.getAreas().getDirecciones() != null
				&& procedimientos.getAreas().getDirecciones().getIdDireccion() != null) {
			where.append(" AND t3.ID_DIRECCION = ?");
			params.add(procedimientos.getAreas().getDirecciones().getIdDireccion());
		}
		if (procedimientos != null && procedimientos.getAreas() != null
				&& procedimientos.getAreas().getDescripcionCastellano() != null) {
			where.append(" AND UPPER(t3.DESCRIPCION_CASTELLANO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(procedimientos.getAreas().getDescripcionCastellano().toUpperCase() + "%");
			} else {
				params.add("%" + procedimientos.getAreas().getDescripcionCastellano().toUpperCase() + "%");
			}
			where.append(" AND t3.DESCRIPCION_CASTELLANO IS NOT NULL");
		}
		if (procedimientos != null && procedimientos.getAreas() != null
				&& procedimientos.getAreas().getDescripcionEuskera() != null) {
			where.append(" AND UPPER(t3.DESCRIPCION_EUSKERA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(procedimientos.getAreas().getDescripcionEuskera().toUpperCase() + "%");
			} else {
				params.add("%" + procedimientos.getAreas().getDescripcionEuskera().toUpperCase() + "%");
			}
			where.append(" AND t3.DESCRIPCION_EUSKERA IS NOT NULL");
		}
		if (procedimientos != null && procedimientos.getAreas() != null
				&& procedimientos.getAreas().getFechaRegistro() != null) {
			where.append(" AND t3.FECHA_REGISTRO = ?");
			params.add(procedimientos.getAreas().getFechaRegistro());
		}
		if (procedimientos != null && procedimientos.getAreas() != null
				&& procedimientos.getAreas().getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t3.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(procedimientos.getAreas().getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + procedimientos.getAreas().getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t3.USUARIO_REGISTRO IS NOT NULL");
		}
		if (procedimientos != null && procedimientos.getCodProcedureId() != null) {
			where.append(" AND UPPER(t1.COD_PROCEDURE_ID) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(procedimientos.getCodProcedureId().toUpperCase() + "%");
			} else {
				params.add("%" + procedimientos.getCodProcedureId().toUpperCase() + "%");
			}
			where.append(" AND t1.COD_PROCEDURE_ID IS NOT NULL");
		}
		if (procedimientos != null && procedimientos.getCamposTituloExpediente() != null) {
			where.append(" AND UPPER(t1.CAMPOS_TITULO_EXPEDIENTE) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(procedimientos.getCamposTituloExpediente().toUpperCase() + "%");
			} else {
				params.add("%" + procedimientos.getCamposTituloExpediente().toUpperCase() + "%");
			}
			where.append(" AND t1.CAMPOS_TITULO_EXPEDIENTE IS NOT NULL");
		}
		if (procedimientos != null && procedimientos.getDescripcionCastellano() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_CASTELLANO) like ? ESCAPE '\\'");
			if (startsWith) {
				params.add(procedimientos.getDescripcionCastellano().toUpperCase() + "%");
			} else {
				params.add("%" + procedimientos.getDescripcionCastellano().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_CASTELLANO IS NOT NULL");
		}
		if (procedimientos != null && procedimientos.getDescripcionEuskera() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_EUSKERA) like ? ESCAPE '\\'");
			if (startsWith) {
				params.add(procedimientos.getDescripcionEuskera().toUpperCase() + "%");
			} else {
				params.add("%" + procedimientos.getDescripcionEuskera().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_EUSKERA IS NOT NULL");
		}
		if (procedimientos != null && procedimientos.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(procedimientos.getFechaRegistro());
		}
		if (procedimientos != null && procedimientos.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(procedimientos.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + procedimientos.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

	/**
	 * Finds rows in the Procedimientos table using like.
	 *
	 * @param idDocumento
	 *            Integer
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * 
	 * @return List<Procedimientos>
	 */
	@Transactional(readOnly = true)
	public List<Procedimientos> obtenerProcedimientosDoc(Integer idDocumento, JQGridRequestDto jqGridRequestDto) {
		StringBuilder query = new StringBuilder();

		query.append(
				"SELECT T10.ID_PROCEDIMIENTO AS IDPROCEDIMIENTO, t01.DESCRIPCION_CASTELLANO AS DESCRIPCIONCASTELLANO, t01.DESCRIPCION_EUSKERA AS DESCRIPCIONEUSKERA");
		query.append(" FROM PROCEDIMIENTOS t01");
		query.append(" INNER JOIN PLANTILLAS t10 ON t10.ID_PROCEDIMIENTO = t01.ID_PROCEDIMIENTO");
		query.append(" WHERE t10.ID_DOCUMENTO = ?");

		List<Object> params = new ArrayList<Object>();
		params.add(idDocumento);

		if (jqGridRequestDto != null) {
			query = JQGridManager.getPaginationQuery(jqGridRequestDto, query,
					ProcedimientosDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMapProcedimientosDoc, params.toArray());
	}

	/**
	 * Counts rows in the REL_PLA_CAM table using like.
	 *
	 * @param idDocumento
	 *            Integer
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long obtenerProcedimientosDocCount(Integer idDocumento) {
		StringBuilder query = new StringBuilder();

		query.append("SELECT COUNT(1)");
		query.append(" FROM PROCEDIMIENTOS t01");
		query.append(" INNER JOIN PLANTILLAS t10 ON t10.ID_PROCEDIMIENTO = t01.ID_PROCEDIMIENTO");
		query.append(" WHERE t10.ID_DOCUMENTO = ?");

		List<Object> params = new ArrayList<Object>();
		params.add(idDocumento);

		return this.jdbcTemplate.queryForLong(query.toString(), params.toArray());
	}
}
